<template>
  <BaseLoader v-if="postsForPeriod.length === 0" />
  <main class="timeline-section" v-else>
    <TabView @tab-click="setPeriod($event)">
      <TabPanel v-for="period in periods" :key="period" :header="period">
        <TimelinePost
          v-for="post in postsForPeriod"
          :key="post.id"
          :post="post"
        />
      </TabPanel>
    </TabView>
  </main>
</template>

<script lang="ts">
import { defineComponent, ref, computed } from "vue"
import { useStore, store } from "@/store"

import { Period, Post } from "@/types"

import moment from "moment"

import TimelinePost from "@/components/Home/Timeline/Post/index.vue"
import BaseLoader from "@/components/shared/BaseLoader/index.vue"
import TabView from "primevue/tabview"
import TabPanel from "primevue/tabpanel"

export default defineComponent({
  components: {
    TimelinePost,
    TabView,
    TabPanel,
    BaseLoader,
  },
  async setup() {
    const periods: Period[] = ["today", "this week", "this month"]

    // tests not running
    // const state = useState()

    if (store.state.posts.loaded === false) {
      await store.dispatch("fetchPosts")
    }

    const allPosts = store.state.posts.ids.reduce<Post[]>((acc, id) => {
      const post = store.state.posts.all[id]
      return acc.concat(post)
    }, [])
    const postsForPeriod = computed(() => {
      return allPosts.filter((post: Post) => {
        if (
          selectedPeriod.value === "today" &&
          post.created.isAfter(moment().subtract(1, "day"))
        ) {
          return true
        }
        if (
          selectedPeriod.value === "this week" &&
          post.created.isAfter(moment().subtract(7, "day"))
        ) {
          return true
        }
        if (
          selectedPeriod.value === "this month" &&
          post.created.isAfter(moment().subtract(1, "month"))
        ) {
          return true
        }
        return false
      })
    })
    const selectedPeriod = ref<Period>("today")
    const setPeriod = ($event: any) => {
      selectedPeriod.value = periods[$event.index]
    }

    return {
      periods,
      selectedPeriod,
      setPeriod,
      postsForPeriod,
    }
  },
})
</script>
